#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int pole[100][100];
int rows = 0;
int columns = 0;
int endR;
int endC;
int skokDoCile = 10000;

void program(int novaR, int novaC, int skoku) {
	printf("point1 %d %d\n", novaR, novaC);
	if (novaR <= 0 || novaC <= 0) {
		return;
	}
	if (novaR > rows || novaC > columns) {
		return;
	}

	if (pole[novaR][novaC] == 1) {
		return;
	}
	pole[novaR][novaC] = 1;

	if (novaR == endR && novaC == endC) {
		if (skoku < skokDoCile) {
			skokDoCile = skoku;
			return;
		}
	}

	// Skoky
	program(novaR+2, novaC+1, skoku+1);
	program(novaR+1, novaC+2, skoku+1);
	program(novaR+2, novaC-1, skoku+1);
	program(novaR+1, novaC-2, skoku+1);
	program(novaR-1, novaC+2, skoku+1);
	program(novaR-2, novaC+1, skoku+1);
	program(novaR-1, novaC-2, skoku+1);
	program(novaR-2, novaC-1, skoku+1);
	
	pole[novaR][novaC] = 0;
}


int main(void) {
	int startR, startC;

	while(scanf("%d %d %d %d %d %d\n", &rows, &columns, &startR, &startC, &endR, &endC) == 6) {
		skokDoCile = 10000;
		//printf("Nahovno");
		memset(pole, 0, sizeof(int)*10000);
		program(startR, startC,0);
		if (skokDoCile == 10000) {
			printf("impossible\n");
		} else {
			printf("%d", skokDoCile);
		}
	}
	return 0;
}